/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.bookstore.service;

import cz.cvut.kbss.bookstore.dto.BookDto;
import java.util.List;

/**
 *
 * @author mickapa1
 */
public interface BookService {
    /**
     * Get all books stored in the system
     * @return 
     */
    public List<BookDto> getAllBooks();
    /**
     * Get all books owned by the given user
     * @param userId identifier of the user
     * @return users books
     */
    public List<BookDto> getUsersBooks(Long userId);
    /**
     * Add book to the system
     * @param title title of the book
     * @param owner id of the owner
     * @return identifier of the newly added book
     */
    public Long addBook(String title, Long owner);
    /**
     * Deletes book from the system
     * @param bookId idenfier of the book to be removed
     */
    public void deleteBook(Long bookId);
}
